#!/bin/sh

if [ $# -ne 2 ]; then
	echo "$0 [pingip] [missnum]"
	exit 1
fi

pingip=$1
missnum=$2

. /etc/PG.conf
laststat=down
standby=/etc/standby
RAMDISK=/usr/ramdisk
IPECTRL=${RAMDISK}/bin/ipectrl 
FLOWEYE=${RAMDISK}/bin/floweye

webconf=${PGETC}/hasync.conf
actlog=${RAMDISK}/tmp/actlog.log

[ ! -f ${webconf} ] && exit 1
.  ${webconf}

stop_panaos()
{
        sleep .1
        errmsg=`${IPECTRL} stop panaos`
        sleep .1
        errmsg=`${IPECTRL} stop panaos`

        # Waiting panaos exit
        count=50
        while [ ${count} -gt 0 ]; do
                panaos=`ps ax | awk '{print $5}' | grep panaos`
                [ "${panaos}" = "" ] && break
                sleep .2
                count=$((${count} - 1))
        done
}

start_panaos()
{
        local cnt=30

        ${IPECTRL} start panaos

        while [ ${cnt} -gt 0 ]; do
                err=`/usr/ramdisk/bin/floweye system stat`
                [ "$?" = "0" ] && return 0
                sleep 1
                cnt=$((${cnt} - 1))
        done

        return 1
}

while true; do

	loop=0
	count=0

	while [ $loop -lt $missnum ]; do
		errmsg=`${FLOWEYE} ping if=_HAPING_ ip=${pingip} count=1 | grep ^Reply`
		[ "${errmsg}" == "" ] && count=$(($count+1))
		loop=$(($loop+1))
		sleep 1
	done

	curtime=`date +"%Y-%m-%d %H:%M.%S"`
	if [ $count -eq $missnum ]; then
		#from backup_mode goto active mode
		if [ -f ${standby} ]; then
			stop_panaos
			rm ${standby}
			start_panaos
			${FLOWEYE} nat addrtif name=_HAPING_ ifname=${halan_if} addr=${halan_ip} netmask=${halan_mask} vlan=${halan_vlan}
			echo "[${curtime}]: Զлģʽ" >> ${actlog}
		fi
	else
		#from active_mode goto backup_mode
		if [ ! -f ${standby} ]; then
			stop_panaos
			[ ! -f ${standby} ] && touch ${standby}
			start_panaos
			${FLOWEYE} nat addrtif name=_HAPING_ ifname=${halan_if} addr=${halan_ip} netmask=${halan_mask} vlan=${halan_vlan}
			echo "[${curtime}]: Զл뱸ģʽ" >> ${actlog}
		fi
	fi
done
